# funkcie - pravé funkcie a modifikátory


class Student:
    pass

def prirad(m, p):
    osoba = Student()
    osoba.meno = m
    osoba.priezvisko = p
    return osoba
 

chlapec=prirad('Tomáš','Mrkvička')
dievca=prirad('Mária','Nováková')




def zakladne_info(person):
    print('Volá sa', person.meno, person.priezvisko)

zakladne_info(chlapec)
zakladne_info(dievca)

print('------------------')









# funkcia kopia, ktorá na základe jedného objektu vyrobí nový, ktorý je jeho kópiou

def kopia(iny):                                        # funkcia kopia na základe jedného objektu vyrobí nový, ktorý je jeho kópiou 
    osoba = Student()
    osoba.meno = iny.meno
    osoba.priezvisko = iny.priezvisko
    return osoba

sestra = kopia(dievca)                                 # pomocou funkcie kopia vieme definovať nové objekty typu Student, ktoré už budú mať vytvorené oba atribúty meno a priezvisko
mama = kopia(dievca)                                   # všetky tri inštancie dievca, sestra a mama majú svoje vlastné súkromné premenné meno a priezvisko  
sestra.meno = 'Jana'                                   # zmenou hodnoty niektorého atribútu sa nemení obsah zvyšných dvoch inštancií
mama.meno = 'Eva'                                      # zmenou hodnoty niektorého atribútu sa nemení obsah zvyšných dvoch inštancií     

zakladne_info(dievca)
zakladne_info(sestra)
zakladne_info(mama)

print('------------------')





mama.priezvisko='Mrkvičková'                           # zmenou hodnoty niektorého atribútu sa nemení obsah zvyšných dvoch inštancií

zakladne_info(dievca)
zakladne_info(sestra)
zakladne_info(mama)

print('------------------')







dievca.priezvisko='Sováková'                          # zmenou hodnoty niektorého atribútu sa nemení obsah zvyšných dvoch inštancií

zakladne_info(dievca)
zakladne_info(sestra)
zakladne_info(mama)

print('------------------')









# nepravé funkcie ako modifikátory

dievca.trvaly_pobyt='Prešov'
print(dievca.meno+' má od detstva pekné spomienky na '+dievca.trvaly_pobyt)


def bydlisko(osoba, text):
    osoba.trvaly_pobyt = text

bydlisko(dievca,'Košice')                                                   # zmena hodnoty atribútu trvaly_pobyt inštancie dievca
bydlisko(sestra,'Košice')                                                   # vytvorenie a nastavenie hodnoty atribútu trvaly_pobyt inštancie sestra

print(dievca.meno+' má už lepšie spomienky na '+dievca.trvaly_pobyt)
print(sestra.meno+' momentálne spoznáva '+sestra.trvaly_pobyt)
#print(mama.meno+' má od detstva pekné spomienky na '+mama.trvaly_pobyt)    # inštancia mama nemá atribút trvaly_pobyt





